package com.zhentao.service.impl;

import com.zhentao.result.ResultVo;
import com.zhentao.service.TestService;
import org.springframework.stereotype.Service;
import org.springframework.util.DigestUtils;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;
import java.util.TreeMap;

@Service
public class TestServiceImpl implements TestService {
    private static final String APP_SECRET = "123";
    @Override
    public ResultVo checkSign(Integer goodsId, HttpServletRequest request) {
        String reqId = request.getHeader("reqId");
        String reqTime = request.getHeader("reqTime");
        String appId = request.getHeader("appId");
        String sign = request.getHeader("sign");
        Map<String, String> map = new TreeMap<>();
        map.put("goodsId", goodsId.toString());
        map.put("reqId", reqId);
        map.put("reqTime", reqTime.toString());
        map.put("appId", appId);
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, String> entry : map.entrySet()) {
            sb.append(entry.getKey()).append("=").append(entry.getValue()).append("&");
        }
        sb.append(APP_SECRET); // 最后拼接appSecret
        String s = DigestUtils.md5DigestAsHex(sb.toString().getBytes());
        if (!s.equalsIgnoreCase(sign)) {
            System.err.println("签名验证失败");
            return ResultVo.failed("签名验证失败",null);
        }
        System.err.println("签名验证成功");
        // 5. 返回成功结果
        return ResultVo.success("RemiK80",sb.toString());
    }
}
